ghc-lib-parser-9.10.1.20250103: The GHC API, decoupled from GHC versions

Safe Haskell | Ignore
Language | GHC2021

GHC.Core.Map.Expr

Contents

- Maps over Core expressions
- Alpha equality
- `TrieMap` class reexports
- Orphan instances

Synopsis

- data CoreMap a
- emptyCoreMap :: CoreMap a
- extendCoreMap :: CoreMap a -> CoreExpr -> a -> CoreMap a
- lookupCoreMap :: CoreMap a -> CoreExpr -> Maybe a
- foldCoreMap :: (a -> b -> b) -> b -> CoreMap a -> b
- eqDeBruijnExpr :: DeBruijn CoreExpr -> DeBruijn CoreExpr -> Bool
- eqCoreExpr :: CoreExpr -> CoreExpr -> Bool
- class Functor m => TrieMap (m :: Type -> Type) where
  - type Key (m :: Type -> Type)
  - emptyTM :: m a
  - lookupTM :: Key m -> m b -> Maybe b
  - alterTM :: Key m -> XT b -> m b -> m b
  - filterTM :: (a -> Bool) -> m a -> m a
  - foldTM :: (a -> b -> b) -> m a -> b -> b
- insertTM :: TrieMap m => Key m -> a -> m a -> m a
- deleteTM :: TrieMap m => Key m -> m a -> m a
- lkDFreeVar :: Var -> DVarEnv a -> Maybe a
- xtDFreeVar :: Var -> XT a -> DVarEnv a -> DVarEnv a
- lkDNamed :: NamedThing n => n -> DNameEnv a -> Maybe a
- xtDNamed :: NamedThing n => n -> XT a -> DNameEnv a -> DNameEnv a
- (>.>) :: (a -> b) -> (b -> c) -> a -> c
- (|>) :: a -> (a -> b) -> b
- (|>>) :: TrieMap m2 => (XT (m2 a) -> m1 (m2 a) -> m1 (m2 a)) -> (m2 a -> m2 a) -> m1 (m2 a) -> m1 (m2 a)

# Maps over Core expressions

data CoreMap a #

`CoreMap a` is a map from `CoreExpr` to `a`. If you are a client, this is the type you want.

#### Instances

Instances details

Functor CoreMap # |
Instance details Defined in GHC.Core.Map.Expr Methods fmap :: (a -> b) -> CoreMap a -> CoreMap b # (<$) :: a -> CoreMap b -> CoreMap a #
TrieMap CoreMap # |

Instance details

Defined in GHC.Core.Map.Expr

Associated Types

type Key CoreMap |
Instance details Defined in GHC.Core.Map.Expr type Key CoreMap = CoreExpr

Methods

emptyTM :: CoreMap a #

lookupTM :: Key CoreMap -> CoreMap b -> Maybe b #

alterTM :: Key CoreMap -> XT b -> CoreMap b -> CoreMap b #

filterTM :: (a -> Bool) -> CoreMap a -> CoreMap a #

foldTM :: (a -> b -> b) -> CoreMap a -> b -> b #

Outputable a => Outputable (CoreMap a) # |
Instance details Defined in GHC.Core.Map.Expr Methods ppr :: CoreMap a -> SDoc #
type Key CoreMap # |
Instance details Defined in GHC.Core.Map.Expr type Key CoreMap = CoreExpr

emptyCoreMap :: CoreMap a #

extendCoreMap :: CoreMap a -> CoreExpr -> a -> CoreMap a #

lookupCoreMap :: CoreMap a -> CoreExpr -> Maybe a #

foldCoreMap :: (a -> b -> b) -> b -> CoreMap a -> b #

# Alpha equality

eqDeBruijnExpr :: DeBruijn CoreExpr -> DeBruijn CoreExpr -> Bool #

eqCoreExpr :: CoreExpr -> CoreExpr -> Bool #

# `TrieMap` class reexports

class Functor m => TrieMap (m :: Type -> Type) where #

Associated Types

type Key (m :: Type -> Type) #

Methods

emptyTM :: m a #

lookupTM :: Key m -> m b -> Maybe b #

alterTM :: Key m -> XT b -> m b -> m b #

filterTM :: (a -> Bool) -> m a -> m a #

foldTM :: (a -> b -> b) -> m a -> b -> b #

#### Instances

Instances details

TrieMap IntMap # |

Instance details

Defined in GHC.Data.TrieMap

Associated Types

type Key IntMap |
Instance details Defined in GHC.Data.TrieMap type Key IntMap = Int

Methods

emptyTM :: IntMap a #

lookupTM :: Key IntMap -> IntMap b -> Maybe b #

alterTM :: Key IntMap -> XT b -> IntMap b -> IntMap b #

filterTM :: (a -> Bool) -> IntMap a -> IntMap a #

foldTM :: (a -> b -> b) -> IntMap a -> b -> b #

TrieMap LabelMap # |

Instance details

Defined in GHC.Cmm.Dataflow.Label

Associated Types

type Key LabelMap |
Instance details Defined in GHC.Cmm.Dataflow.Label type Key LabelMap = Label

Methods

emptyTM :: LabelMap a #

lookupTM :: Key LabelMap -> LabelMap b -> Maybe b #

alterTM :: Key LabelMap -> XT b -> LabelMap b -> LabelMap b #

filterTM :: (a -> Bool) -> LabelMap a -> LabelMap a #

foldTM :: (a -> b -> b) -> LabelMap a -> b -> b #

TrieMap CoreMap # |

Instance details

Defined in GHC.Core.Map.Expr

Associated Types

type Key CoreMap |
Instance details Defined in GHC.Core.Map.Expr type Key CoreMap = CoreExpr

Methods

emptyTM :: CoreMap a #

lookupTM :: Key CoreMap -> CoreMap b -> Maybe b #

alterTM :: Key CoreMap -> XT b -> CoreMap b -> CoreMap b #

filterTM :: (a -> Bool) -> CoreMap a -> CoreMap a #

foldTM :: (a -> b -> b) -> CoreMap a -> b -> b #

TrieMap BndrMap # |

Instance details

Defined in GHC.Core.Map.Type

Associated Types

type Key BndrMap |
Instance details Defined in GHC.Core.Map.Type type Key BndrMap = Var

Methods

emptyTM :: BndrMap a #

lookupTM :: Key BndrMap -> BndrMap b -> Maybe b #

alterTM :: Key BndrMap -> XT b -> BndrMap b -> BndrMap b #

filterTM :: (a -> Bool) -> BndrMap a -> BndrMap a #

foldTM :: (a -> b -> b) -> BndrMap a -> b -> b #

TrieMap LooseTypeMap # |

Instance details

Defined in GHC.Core.Map.Type

Associated Types

type Key LooseTypeMap |
Instance details Defined in GHC.Core.Map.Type type Key LooseTypeMap = Type

Methods

emptyTM :: LooseTypeMap a #

lookupTM :: Key LooseTypeMap -> LooseTypeMap b -> Maybe b #

alterTM :: Key LooseTypeMap -> XT b -> LooseTypeMap b -> LooseTypeMap b #

filterTM :: (a -> Bool) -> LooseTypeMap a -> LooseTypeMap a #

foldTM :: (a -> b -> b) -> LooseTypeMap a -> b -> b #

TrieMap TypeMap # |

Instance details

Defined in GHC.Core.Map.Type

Associated Types

type Key TypeMap |
Instance details Defined in GHC.Core.Map.Type type Key TypeMap = Type

Methods

emptyTM :: TypeMap a #

lookupTM :: Key TypeMap -> TypeMap b -> Maybe b #

alterTM :: Key TypeMap -> XT b -> TypeMap b -> TypeMap b #

filterTM :: (a -> Bool) -> TypeMap a -> TypeMap a #

foldTM :: (a -> b -> b) -> TypeMap a -> b -> b #

TrieMap VarMap # |

Instance details

Defined in GHC.Core.Map.Type

Associated Types

type Key VarMap |
Instance details Defined in GHC.Core.Map.Type type Key VarMap = Var

Methods

emptyTM :: VarMap a #

lookupTM :: Key VarMap -> VarMap b -> Maybe b #

alterTM :: Key VarMap -> XT b -> VarMap b -> VarMap b #

filterTM :: (a -> Bool) -> VarMap a -> VarMap a #

foldTM :: (a -> b -> b) -> VarMap a -> b -> b #

Ord k => TrieMap (Map k) # |

Instance details

Defined in GHC.Data.TrieMap

Associated Types

type Key (Map k) |
Instance details Defined in GHC.Data.TrieMap type Key (Map k) = k

Methods

emptyTM :: Map k a #

lookupTM :: Key (Map k) -> Map k b -> Maybe b #

alterTM :: Key (Map k) -> XT b -> Map k b -> Map k b #

filterTM :: (a -> Bool) -> Map k a -> Map k a #

foldTM :: (a -> b -> b) -> Map k a -> b -> b #

(Eq (Key m), TrieMap m) => TrieMap (GenMap m) # |

Instance details

Defined in GHC.Data.TrieMap

Associated Types

type Key (GenMap m) |
Instance details Defined in GHC.Data.TrieMap type Key (GenMap m) = Key m

Methods

emptyTM :: GenMap m a #

lookupTM :: Key (GenMap m) -> GenMap m b -> Maybe b #

alterTM :: Key (GenMap m) -> XT b -> GenMap m b -> GenMap m b #

filterTM :: (a -> Bool) -> GenMap m a -> GenMap m a #

foldTM :: (a -> b -> b) -> GenMap m a -> b -> b #

TrieMap m => TrieMap (ListMap m) # |

Instance details

Defined in GHC.Data.TrieMap

Associated Types

type Key (ListMap m) |
Instance details Defined in GHC.Data.TrieMap type Key (ListMap m) = [Key m]

Methods

emptyTM :: ListMap m a #

lookupTM :: Key (ListMap m) -> ListMap m b -> Maybe b #

alterTM :: Key (ListMap m) -> XT b -> ListMap m b -> ListMap m b #

filterTM :: (a -> Bool) -> ListMap m a -> ListMap m a #

foldTM :: (a -> b -> b) -> ListMap m a -> b -> b #

TrieMap m => TrieMap (MaybeMap m) # |

Instance details

Defined in GHC.Data.TrieMap

Associated Types

type Key (MaybeMap m) |
Instance details Defined in GHC.Data.TrieMap type Key (MaybeMap m) = Maybe (Key m)

Methods

emptyTM :: MaybeMap m a #

lookupTM :: Key (MaybeMap m) -> MaybeMap m b -> Maybe b #

alterTM :: Key (MaybeMap m) -> XT b -> MaybeMap m b -> MaybeMap m b #

filterTM :: (a -> Bool) -> MaybeMap m a -> MaybeMap m a #

foldTM :: (a -> b -> b) -> MaybeMap m a -> b -> b #

Uniquable key => TrieMap (UniqDFM key) # |

Instance details

Defined in GHC.Data.TrieMap

Associated Types

type Key (UniqDFM key) |
Instance details Defined in GHC.Data.TrieMap type Key (UniqDFM key) = key

Methods

emptyTM :: UniqDFM key a #

lookupTM :: Key (UniqDFM key) -> UniqDFM key b -> Maybe b #

alterTM :: Key (UniqDFM key) -> XT b -> UniqDFM key b -> UniqDFM key b #

filterTM :: (a -> Bool) -> UniqDFM key a -> UniqDFM key a #

foldTM :: (a -> b -> b) -> UniqDFM key a -> b -> b #

insertTM :: TrieMap m => Key m -> a -> m a -> m a #

deleteTM :: TrieMap m => Key m -> m a -> m a #

lkDFreeVar :: Var -> DVarEnv a -> Maybe a #

xtDFreeVar :: Var -> XT a -> DVarEnv a -> DVarEnv a #

lkDNamed :: NamedThing n => n -> DNameEnv a -> Maybe a #

xtDNamed :: NamedThing n => n -> XT a -> DNameEnv a -> DNameEnv a #

(>.>) :: (a -> b) -> (b -> c) -> a -> c infixr 1 #

(|>) :: a -> (a -> b) -> b infixr 1 #

(|>>) :: TrieMap m2 => (XT (m2 a) -> m1 (m2 a) -> m1 (m2 a)) -> (m2 a -> m2 a) -> m1 (m2 a) -> m1 (m2 a) infixr 1 #

# Orphan instances

Eq (DeBruijn CoreAlt) # |
Instance details Methods (==) :: DeBruijn CoreAlt -> DeBruijn CoreAlt -> Bool # (/=) :: DeBruijn CoreAlt -> DeBruijn CoreAlt -> Bool #
Eq (DeBruijn CoreExpr) # |
Instance details Methods (==) :: DeBruijn CoreExpr -> DeBruijn CoreExpr -> Bool # (/=) :: DeBruijn CoreExpr -> DeBruijn CoreExpr -> Bool #